<?php
 
/*
Use : pvOutput.php sid=SID key=KEY val=DATE|TIME|ENERGY|POWER|ENERGY_C|POWER_C|EFFICIENCY|TEMPERATURE|VOLTAGE
*/

require_once dirname(__FILE__) . '/../../../../core/php/core.inc.php';

if (isset($argv)) 
{
    foreach ($argv as $arg) 
	{
      	$argList = explode('=', $arg);
      	if (isset($argList[0]) && isset($argList[1])) 
		{
        	$_GET[$argList[0]] = $argList[1];
      	}
    }
}

$url = 'http://pvoutput.org/service/r2/getstatus.jsp';
switch ($argc) 
{
  	case 4:
        if (isset($_GET['sid']) && isset($_GET['key']) && isset($_GET['val']) ) 
		{			            
			// echo $_GET['sid'] . " : " . $_GET['key'];
            
            $url = $url . '?sid=' . $_GET['sid'] . '&key=' . $_GET['key'];
            $val = $_GET['val'];
			
        } 
		else 
		{
          	$err = 'ERROR : Problems with arguments. Arguments are [sid=SID key=KEY val=DATE|TIME|ENERGY|POWER|ENERGY_C|POWER_C|EFFICIENCY|TEMPERATURE|VOLTAGE] !';
        }
  		break;
        
	default:
  		$err = 'ERROR : Missing arguments or too much arguments !';
}

if (!isset($err)) 
{
	// echo $url;
  
	try 
	{      
		$request = new com_http($url);		
		$station = $request->exec(10000, 4);
    } 
	catch (Exception $e) 
	{             
		$station = '';          
    }
 
	// echo $station;
    
    $return = array();
    $values = explode(',', $station);
    
    if (count($values) == 9)
	{
        switch ($val) 
		{        
        	case 'DATE':
        		echo $values[0]; 					// Date 'yyyymmdd'
        		break;
            case 'TIME':
            	echo $values[1]; 					// Time 'hh:mm'
                break;
          	case 'ENERGY':
                echo floatval($values[2]) / 1000.0; // Energy Generation (watt hours)
                break;
          	case 'POWER':
                echo floatval($values[3]); 			// Power Generation (watt)
                break;
			case 'ENERGY_C':
                echo $values[4]; 					// Energy Consumption (watt hours)
                break;
			case 'POWER_C':
                echo $values[5];					// Power Consumption (watt)
                break;
			case 'EFFICIENCY':
                echo $values[6];					// Efficiency (kWh/kW)
                break;
			case 'TEMPERATURE':
                echo $values[7];					// Temperature (celsius)
                break;
			case 'VOLTAGE':
                echo floatval($values[8]); 			// voltage (volts)
                break;
        }
    }
	else
	{
		echo '?';
	}    
} 
else 
{
	echo $err;
}

?> 